/*
 * NeXThextris Copyright 1994 Mark Gritter, mgritter@gac.edu
 *
 * hextris Copyright 1990 David Markley, dm3e@+andrew.cmu.edu, dam@cs.cmu.edu
 *
 * Permission to use, copy, modify, and distribute, this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holders be used in
 * advertising or publicity pertaining to distribution of the software with
 * specific, written prior permission, and that no fee is charged for further
 * distribution of this software, or any modifications thereof.  The copyright
 * holder make no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDER DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA, PROFITS, QPA OR GPA, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE 
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

#import <objc/Object.h>
#import <appkit/Application.h>
#import "header.h"

@interface HextrisControl:Object
{
	id  hexView;
	id  mainWindow;
	id  scoreText;
	id  rowText;
	id  highScoreWindow;
	id  highScores;
	id  helpWindow;
	id  nextPieceView;
	id  pauseMenuItem;
	id  pauseButton;
	BOOL paused;
	BOOL quickdrop;
	int score, rows, game_over, game_view;
	high_score_t high_scores[MAXHIGHSCORES];
	position_t grid[MAXROW][MAXCOLUMN];
	piece_t piece, npiece;
	char *name, *log_name;
}

- appDidInit:sender;
- pause:sender;
- newGame:sender;
- showScores;
- showHighScores:sender;
- showHelp;
- showNextPiece:(piece_t *)nextpiece;
- tick;
- setQuickDrop:(BOOL)on;
- keyDown:(NXEvent *)theEvent;
- windowDidMiniaturize:sender;
- windowDidResignMain:sender;
- windowDidBecomeMain:sender;

@end
