/*
 * NeXThextris Copyright 1994 Mark Gritter, mgritter@gac.edu
 *
 * hextris Copyright 1990 David Markley, dm3e@+andrew.cmu.edu, dam@cs.cmu.edu
 *
 * Permission to use, copy, modify, and distribute, this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holders be used in
 * advertising or publicity pertaining to distribution of the software with
 * specific, written prior permission, and that no fee is charged for further
 * distribution of this software, or any modifications thereof.  The copyright
 * holder make no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDER DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA, PROFITS, QPA OR GPA, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE 
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

/* Function declarations -- absent in original version of hextris. */

/* NeXThextris only*/
void start_quickdrop(void);
void stop_quickdrop(void);

/* hextris control functions */
void init_piece(piece_t *piece);
void place_piece(piece_t *piece, piece_t *tpiece);
int check_piece(piece_t *tpiece, position_t grid[MAXROW][MAXCOLUMN]);
void drop_piece(piece_t *piece, position_t grid[MAXROW][MAXCOLUMN]);
void redraw_grid(position_t grid[MAXROW][MAXCOLUMN]);
void shift_redraw_grid(int start_row, position_t grid[MAXROW][MAXCOLUMN]);
void shift_offset_redraw_grid(int start_row, position_t grid[MAXROW][MAXCOLUMN]);
int check_rows(position_t grid[MAXROW][MAXCOLUMN]);
int update(int choice, position_t grid[MAXROW][MAXCOLUMN],
			piece_t *npiece, piece_t *piece, int *score, int *rows);
int update_drop(position_t grid[MAXROW][MAXCOLUMN],
			piece_t *npiece, piece_t *piece, int *score, int *rows);
void new_game(position_t grid[MAXROW][MAXCOLUMN],
			piece_t *npiece, piece_t *piece, int *score, int *rows);
void draw_borders(void);
int is_high_score(char name[MAXNAMELENGTH], char userid[MAXUSERIDLENGTH],
			int score, int rows, high_score_t high_scores[MAXHIGHSCORES]);
void do_choice(char choice, position_t grid[MAXROW][MAXCOLUMN],
			piece_t *npiece, piece_t *piece, int *score, int *rows,
			int *game_over, int *game_view, high_score_t high_scores[MAXHIGHSCORES]);
void redraw_game(position_t grid[MAXROW][MAXCOLUMN], piece_t *npiece, piece_t *piece,
			int *score, int *rows, int game_view, high_score_t high_scores[MAXHIGHSCORES]);

/* hextris I/O functions */
void clear_display(void);
void display_scores(int *score, int *rows);
void display_help(void);
void display_high_scores(high_score_t high_scores[MAXHIGHSCORES]);
void show_next_piece(piece_t *npiece);
void draw_hex(int row, int column, int fill, int type);
void end_game();

/* hextris stdsys.c functions */
void new_piece(piece_t *npiece, piece_t *piece);
int read_high_scores(high_score_t high_scores[MAXHIGHSCORES]);
int write_high_scores(high_score_t high_scores[MAXHIGHSCORES], char *uniqueid);





